<?php
/**
 * rdf node editing widget
 * 
 * @package POWL-Widgets
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: node.php,v 1.5 2005/02/23 12:19:32 soerenauer Exp $
 * @access public
 **/

class editliteral extends powlModuleWidget {
	function edit($name,$value,$config=array()) {
		if(!$values)
			$values=!empty($this)&&!empty($this->config['values'])?$this->config['values']:array();
		if(is_array($value))
			$value=new RDFSLiteral($value['value'],$value['lang'],$value['dtype']);
		if(!is_a($value,'literal'))
			$value=new Literal(is_a($value,'Resource')?$value->getURI():$value);
		if(!empty($this))
			$config=array_merge($config,$this->config);
		$ret='<table class="blind"'.(empty($config['fixedSize'])?'':' style="width:100%;height:90%"').'><tbody><tr><td colspan="2">';
		if(!strstr($value->getLabel(),"\n") && (strlen($value->getLabel())<100 || !strstr($value->getLabel(),' ')))
			$ret.='<input type="text" name="'.$name.'[value]"'.
				(!empty($config['AttributeStyle'])?' style="'.$config['AttributeStyle'].'"':'').
				'value="'.htmlspecialchars($value->getLabel()).'" />';
		else
			$ret.='<textarea name="'.$name.'[value]"'.
				(!empty($config['AttributeStyle'])?' style="'.$config['AttributeStyle'].'"':'').
				'>'.$value->getLabel().'</textarea>';
		$ret.=<<<EOM
<script language="javascript">
function getObj(id) {
	if(typeof id=='string') {
		if(document.getElementById(id))
			return document.getElementById(id);
		else
			return document.getElementsByName(id)[0];
	}
	return id;
}
function textVExpand(id) {
	id=getObj(id);

	if(id.type=='text') {
		textarea=document.createElement('textarea');
		textarea.value=id.value;
		textarea.name=id.name;
		textarea.style.width=(id.offsetWidth)+'px';
		textarea.style.display='block';
		id.parentNode.replaceChild(textarea,id);
	} else if(id.type=='textarea')
		id.style.height=(id.offsetHeight+50)+'px';
	textSaveSize(id);
}
function textHExpand(id) {
	id=getObj(id);
	id.style.width=(id.offsetWidth+50)+'px';
	textSaveSize(id);
}
function textHReduce(id) {
	id=getObj(id);
	id.style.width=(id.offsetWidth-50)+'px';
	textSaveSize(id);
}
function textVReduce(id) {
	id=getObj(id);
	old=id.offsetHeight;
	if(id.type=='textarea' && old<60) {
		text=document.createElement('input');
		text.value=id.value;
		text.name=id.name;
		text.style.width=(id.offsetWidth)+'px';
		id.parentNode.replaceChild(text,id);
	} else
		id.style.height=(id.offsetHeight-50)+'px';
	textSaveSize(id);
}
function textSaveSize(id) {
	powl.setState('textedit'+id.type+id.name,'width',id.offsetWidth);
	if(id.type=='textarea')
		powl.setState('textedit'+id.type+id.name,'height',id.offsetHeight);
}
function textResize(id) {
	id=getObj(id);
	if(width=powl.getState('textedit'+id.type+id.name,'width')) {
		id.style.width=width+'px';
		if(id.type=='textarea')
			id.style.height=powl.getState('textedit'+id.type+id.name,'height')+'px';
	}
}
EOM;
		if(empty($config['fixedSize']))
			$ret.='powl.SafeAddOnload(function() { textResize("'.$name.'[value]"); });';
		else
			$ret.='window.onresize=function() { getObj("'.$name.'[value]").style.height=window.innerHeight-105+\'px\'; }; getObj("'.$name.'[value]").style.height=window.innerHeight-105+\'px\';';
		$ret.='</script>';
		$ret.='</td></tr><tr>';
		$ret.='<td><input type="text" name="'.$name.'[lang]" value="'.($value->getLanguage()?$value->getLanguage():'Lang').'" style="width:30px" onclick="if(this.value==\'Lang\') this.value=\'\'" onblur="if(this.value==\'\') this.value=\'Lang\'" />';
		$s=new select(array('cardinalityMax'=>1));
		$ret.=$s->edit($name.'[dtype]',$value->getDatatype(),array_merge(array(''=>pwl_('Datatype')),$GLOBALS['_POWL']['datatypes'])).'</td>';
		if(empty($config['fixedSize']))
			$ret.='<td align="right"><a href="#" onclick="textHReduce(\''.$name.'[value]\')" title="Horizontally reduce text field.">[&lt;]</a>&nbsp;<a href="#" onclick="textVReduce(\''.$name.'[value]\')" title="Vertically reduce text field.">[&and;]</a>&nbsp;<a href="#" onclick="textVExpand(\''.$name.'[value]\')" title="Vertically expand text field.">[&or;]</a>&nbsp;<a href="#" onclick="textHExpand(\''.$name.'[value]\')" title="Horizontally expand text field.">[&gt;]</a></td>';
		$ret.='</tr></tbody></table>';
		return $ret;
	}
}
class editnode extends powlModuleWidget {
	function edit($name,$value,$config=array()) {
		if(!$values)
			$values=!empty($this)&&!empty($this->config['values'])?$this->config['values']:array();
		if(!empty($this))
			$config=array_merge($config,$this->config);
		if(is_array($value) && $value['value']) {
			if($value['type']=='literal')
				$value=new RDFSLiteral($value['value'],$value['lang'],$value['dtype']);
			else
				$value=new Resource($value['value']);
		}
		$opts=array('resource'=>'Resource','literal'=>'Literal');
		if($value)
			$opts['remove']='Remove';
		$ret=checkbox::edit($name.'[type]',is_a($value,'Literal')?'literal':'resource',$opts,array('cardinality'=>1));
		$ret.='<div id="resource">'.selectResource::edit($name.'[uri]',$value,array_merge($config,array('cardinality'=>1))).'</div>';
		$ret.='<div id="literal">'.editLiteral::edit($name,$value,array_merge($config,array('cardinality'=>1))).'</div>';
		return $ret;
	}
}
?>