<?
/**
 * RDFSmodel
 * 
 * @package RDFSAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: model.php,v 1.6 2004/12/22 18:38:16 soerenauer Exp $
 * @access public
 **/
class RDFSModel extends DefaultRDFSModel {
	function RDFSModel($store,$modelURI) {
		$modelVars =& $store->dbConn->execute("SELECT modelURI, modelID, baseURI FROM models WHERE modelURI='" .$modelURI ."'");
		$this->modelID 	= $modelVars->fields[1];
		$this->baseURI 	= $this->_checkBaseURI($modelVars->fields[2]);
		parent::DefaultRDFSModel($store,$modelURI);
	}
	function listTopClasses() {
		$args=func_get_args();
		$c=cache('listTopClasses'.$this->modelURI,$args);
		if($c!==NULL)
			return $c;
		$clsql='';
		foreach($this->vocabulary['Class'] as $cl)
			$clsql.=" OR s1.object='".$cl->getURI()."'";
		$sql="SELECT s1.subject,s1.subject_is,s2.object_is,s2.object,
				".(!strcasecmp($GLOBALS['_POWL']['db']['type'],'SQLite')?'0':"count(distinct s2.object_is)")." cois
		      FROM statements s1 LEFT JOIN statements s2
		         ON(s1.subject=s2.subject AND s2.modelID IN (".$this->getModelIds().") AND s2.predicate='".$this->_dbId('RDFS_subClassOf')."')
		      WHERE
			     s1.subject_is<>'b' AND s1.predicate='".$this->_dbId('RDF_type')."' AND (0 $clsql)
		         AND s1.modelID IN (".$this->getModelIds().")
			  GROUP BY s1.subject
			  HAVING (cois=0 OR ISNULL(s2.object_is)) OR (cois=1 AND s2.object_is='b') OR
			  	s2.object='".$this->_dbId('RDFS_Resource')."' OR
				(0 AND s2.object_is='r' AND s2.object NOT LIKE '".$this->baseURI."%')
			  ORDER BY s1.subject";
#print_r($sql);
		$topclasses=$this->_convertRecordSetToNodeList($this->dbConn->execute($sql),$this->vclass);
		return cache('listTopClasses'.$this->modelURI,$args,$topclasses);
 	}
	function countClasses($includeImports=true) {
		$clsql='';
		foreach($this->vocabulary['Class'] as $cl)
			$clsql.=" OR object='".$cl->getURI()."'";
		return $this->dbConn->getOne("SELECT COUNT(modelID) FROM statements
			WHERE modelID IN (".($includeImports?$this->getModelIds():$this->modelID).")
				AND subject_is!='b'	AND predicate='".$this->_dbId('RDF_type')."' AND (0 $clsql)");
	}
	function getInstance($uri) {
		$res=is_a($uri,'Resource')?$uri:new $this->resource($uri,$this);
		$uri=$res->getURI();
		foreach($this->vocabulary['Class'] as $class) {
			$q="SELECT ?x WHERE (<".$uri.">,<rdf:type>,?x) (?x,<rdf:type>,<".$class->getURI().">)";
			$instance=$this->rdqlQuery($q);
			if($instance[0]['?x'])
				return new $this->instance($uri,$this);
		}
		return false;
	}
	function countProperties($includeImports=true) {
		$clsql='';
		foreach($this->vocabulary['Property'] as $cl)
			$clsql.="OR object='".$this->_dbId($cl)."'";
		return $this->dbConn->getOne("SELECT COUNT(modelID) FROM statements
			WHERE modelID IN (".($includeImports?$this->getModelIds():$this->modelID).")
				AND predicate='".$this->_dbId('RDF_type')."' AND (0 $clsql)");
	}
}
?>